﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;

namespace WindowsFormsApplication35
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.ultraOptionSet1.CreationFilter = new MyOptionSetCreationFilter();
        }

        private void Form1_Load(object sender, EventArgs e)
        {            
        }
    }

    public class MyOptionSetCreationFilter : IUIElementCreationFilter
    {
        #region IUIElementCreationFilter Members

        public void AfterCreateChildElements(UIElement parent)
        {
            if (parent is OptionSetEmbeddableUIElement)
            {
                foreach (UIElement element in parent.ChildElements)
                {
                    ValueListItem item = element.GetContext(typeof(ValueListItem)) as ValueListItem;
                    switch (item.DataValue.ToString())
                    {
                        case "ValueListItem0":
                            element.Rect = new Rectangle(0, 0, element.Rect.Width, element.Rect.Height);
                            break;
                        case "ValueListItem1":
                            element.Rect = new Rectangle(20, 50, element.Rect.Width, element.Rect.Height);
                            break;
                        case "ValueListItem2":
                            element.Rect = new Rectangle(15, 70, element.Rect.Width, element.Rect.Height);
                            break;
                    }
                }
            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            // Do nothing
            return false;
        }

        #endregion
    }

}
